' QSnap.Inc  Prozeduren: Snap_Var und Snap_Ber  Hexanzeige eines Variableninhalts (String-
'                                               variable und Bereichsvariable)

' Eine Beschreibung der Prozedur ist in QSnap.prf enthalten

' Version 6.1  12.03.2005.     Die Prozedur kann frei benutzt werden, fr
'                              Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka
'                       email: g.putschalka@web.de
'                    homepage: http://members.telering.at/g.putschalka/index.html


Declare   QSnap_Abc#,QSnap_Cycle%,QSnap_File$  ' global definiert!
Def OpenFil(7)  ! "KERNEL32","CreateFileA"
Def WritFil(5)  ! "KERNEL32","WriteFile"
Def SetFileP(4) ! "KERNEL32","SetFilePointer"
Def ClosFil(1)  ! "KERNEL32","CloseHandle"
Def DelFile(1)  ! "KERNEL32","DeleteFileA"

' Hilfsprozedur. Konvertiere einen LongInt-Wert als 4-Byte Binrwert in eine Stringvariable
Proc Konvertiere_in_Binr
  Parameters Wert&
  Declare B0$,B1$,B2$,B3$,B4$,X%
  B4$ = @Chr$(0)
  B3$ = @Chr$(0)
  B2$ = @Chr$(0)
  B1$ = @Chr$(0)
  IfNot (Wert& < 16777216)
    X% = @Div&(Wert&,16777216)
    B4$ = @Chr$(X%)
    Wert& = (Wert& - 16777216)
  EndIf
  IfNot (Wert& < 65536)
    X% = @Div&(Wert&,65536)
    B3$ = @Chr$(X%)
    Wert& = (Wert& - 65536)
  EndIf
  IfNot (Wert& < 256)
    X% = @Div&(Wert&,256)
    B2$ = @Chr$(X%)
    Wert& = (Wert& - 256)
  EndIf
  B1$ = @Chr$(Wert&)
  B0$ = @Add$(@Add$(B1$,B2$),@Add$(B3$,B4$))
  Return B0$
EndProc

Proc ConvAdr
   Parameters Adr2&
   Declare Z1%,Z$,Z1$,C%,C1%
   Z1% = 4
   Dim QSnap_Abc#,8
   Z$ = ""
   Long QSnap_Abc#,0 = Adr2&
   While (Z1% > 0)
      Dec  Z1%
      C1% = @Byte(QSnap_Abc#,Z1%)
      If (C1% > 15)
         C% = @Int(C1% / 16)
         Z1$ = @Hex$(C%)
         C% = (C% * 16)
         C% = (C1% - C%)
         Z1$ = Z1$;@Hex$(C%)
      Else
         Z1$ = "0";@Hex$(C1%)
      EndIf
      Z$ = Z$;Z1$
   EndWhile
   Dispose QSnap_Abc#
   Return Z$
EndProc

' Hilfsprozedur. schreibe den Dump.
Proc Snap_Dump_File
   Parameters Text$
   Declare Zw$,FHandl&,Buffer$,AdrB&,AdrF&,L&
   Dim QSnap_Abc#,256
   String QSnap_Abc#,0 = QSnap_File$
   IfNot QSnap_Cycle%
      @DelFile(QSnap_Abc#) ' lsche, falls vorhanden 
      QSnap_Cycle% = 1
   EndIf
 
   FHandl& = @OpenFil(QSnap_Abc#,$40000000,$2,0,$4,$80,0)

   @SetFileP(FHandl&,0,0,$2) ' anfgen (Append)   

   X4% = 0
   String QSnap_Abc#,0 = "     Dump: "+Text$+@Chr$(13)+Chr$(10)+@Chr$(13)+Chr$(10)
   L& = @Len(@String$(QSnap_Abc#,0))
   WritFil(FHandl&,QSnap_Abc#,L&,QSnap_Abc#+250,0)

   String QSnap_Abc#,0 = "Speicher Rel.  ----------------------- Hex -------------------  \
                          *----- ASCII ----*"+@Chr$(13)+Chr$(10)
   L& = @Len(@String$(QSnap_Abc#,0))
   WritFil(FHandl&,QSnap_Abc#,L&,QSnap_Abc#+250,0)
   While (X4% < @GetCount(Box&))
      Buffer$ = @GetString$(Box&,X4%)+@Chr$(13)+Chr$(10)
      String QSnap_Abc#,0 = Buffer$
      L& = @Len(Buffer$)
      WritFil(FHandl&,QSnap_Abc#,L&,QSnap_Abc#+250,0)
      Inc X4%
   EndWhile

   String QSnap_Abc#,0 = @Chr$(13)+Chr$(10)+@Chr$(13)+Chr$(10)
   L& = @Len(@String$(QSnap_Abc#,0))
   WritFil(FHandl&,QSnap_Abc#,L&,QSnap_Abc#+250,0)

   @ClosFil(FHandl&)
   Dispose QSnap_Abc#
   Return
EndProc

' Hilfsprozedur. Zeige/drucke den Dump.
Proc Snap_All
   Parameters Adr&,Text$,Len%,Opc$
   Declare Zw$,Zw2$,A$,B$,Tab$,Box&,Tabs&,Line%,Ende%,_Dlg%,Bok%,BAbr%,Hdl%,Fnt%,X0%,X1%,X2%,X3%,X4%,Adr1&
   Declare Box0&
   Adr1& = Adr&
   Hdl%  = @GetActiveWindow()
   _Dlg% = @CreateDialog(Hdl%,"",10,10,700,205)
   Bok%  = @CreateButton(_Dlg%,"ok",510,158,70,19)
   BAbr% = @CreateButton(_Dlg%,"Abbruch",610,158,70,20)  

   Text$ = @Add$(@Add$(Text$,"     Lnge-"),@Str$(Len%))
   SetText _Dlg%,Text$
   Fnt% = @CREATEFONT("Courier",10,5,0,0,0)

   Box& = @CreateListBox(_Dlg%,"",2,18,690,137)
   SetFont Box&,Fnt% 

   Box0& = @CreateListBox(_Dlg%,"",2,2,690,18)
   SetFont Box0&,Fnt% 
   @Addstring(Box0&,"Speicher Rel.  ----------------------- Hex -------------------  \
                          *----- ASCII ----*")
   @SendMessage(Box0&,$186,0,0)

   ' anzuzeigende Variable in die Listbox bertragen.
   Ende% = 0
   Line% = 0
   X1% = 0
   WhileNot Ende%
      X2% = 16
      X3% = 16
      ConvAdr Adr1&
      Zw$ = @$(0),@Format$("0000",Line%)," "
      Zw2$ = " *"
      While (X2% > 0)
         A$ = @Char$(Adr&,X1%,1)
         B$ = @HEX$(@Ord(A$))

         Case (@Len(B$) = 1) : B$ = @Add$("0",B$)
         Zw$ = Zw$;B$;" "
         Case @LT$(A$," ") : A$ = @Chr$(95) ' Unterstrich als Ersatz, weil undruckbar
         Zw2$ = @Add$(Zw2$,A$)
         Inc X1%
         Dec X2%
         Dec X3%
         IfNot (X1% < Len%)
            Ende% = 1
            X2% = 0
         EndIf
      EndWhile
      Zw2$ = @Add$(Zw2$,"*")

      ' wenn letzte Zeile < 16 Stellen, ergnze mit Leerstellen
      X3% = (63 - @Len(Zw$))
      Zw$ = Zw$;@Space$(X3%)

      ' setze Hexteil und Klarschriftteil als eine Zeile in die Listbox
      Zw$ = @Add$(Zw$,Zw2$)
      @Addstring(Box&,Zw$)
      Line% = (Line% + 16)
      Adr1& = (Adr1& + 16)
   EndWhile
   ' anzeigen der Listbox und warten bis OK Button
   X3% = 3
   While (X3% = 3)
      WaitInput
      Case (@GetFocus(Bok%)  = 1) : X3% = 0
      Case (@GetFocus(BAbr%) = 1) : X3% = -1     
   EndWhile
   If @Neq$(Opc$,"") and (X3% = 0)
      Snap_Dump_File Text$
   EndIf

   DELETEOBJECT Fnt%
   @Destroywindow(_Dlg%)
   Return X3%
EndProc

' Hauptprozedur Dump Inhalt einer Stringvariablen
Proc Snap_Var
  Parameters X$,Text$,Name$
  Declare Len%,Adr&,Op$
  Op$ = ""
  Case (%PCount > 2) : Op$ = "1"
     
  Len% = @Len(X$)
  Adr& = @Addr(X$)
  Case @Lt$(@Left$($ProfVer,1),"7") : Adr& = (Adr& + 1)
  Snap_All Adr&,Text$,Len%,Op$
  Return
EndProc

' Hauptprozedur Dump Inhalt einer Bereichsvariablen
Proc Snap_Ber
  Parameters Adr&,Text$,Len%,Name$
  Declare Op$
  Case (%PCount < 3) : Len% = 256
  Op$ = ""
  Case (%PCount > 3) : Op$ = "1"
  Snap_All Adr&,Text$,Len%,Op$
  Return
EndProc
' ==============================================================================